# Pandemic

An agent model in which commuting, compliance, testing and contagion parameters drive
infection in a population of thousands of millions. Agents follow Ornstein-Uhlenbeck processes
in the plane and collisions drive transmission. Results are stored at 
<a href="https://www.swarmprediction.com/about.html">SwarmPrediction.com</a> for further analysis, and can be retrieved by anyone.  

![](https://github.com/microprediction/pandemic/blob/master/images/pandemic.png)

### Motivaton 

Covered in this [post](https://www.linkedin.com/pulse/pandemic-minimalist-2d-ornstein-uhlenbeck-model-peter-cotton-phd) with 
the followup [here](https://www.linkedin.com/pulse/dear-new-zealand-heres-how-simulate-covid-19-all-your-cotton-phd/) where possible
improvements are also discussed and acknowledgements are made. See also the SwarmPrediction.Com [list of articles](www.swarmprediction.com/articles.html). The author is not an epidemiologist. The model expresses no opinions
on the health aspects of COVID-19. The model offers a novel motion model with some interesting
analytic properties also discussed in the [article](https://www.linkedin.com/pulse/dear-new-zealand-heres-how-simulate-covid-19-all-your-cotton-phd/) referenced
above and presented in a more technical [working paper](https://www.overleaf.com/read/sgjvfxydcwpk) shared on Overleaf.

### Basic Usage

    pip install pandemic
    >> from pandemic import run
    >> run()
    
See also <a href="https://github.com/microprediction/pandemic/tree/master/examples">examples</a> of
library use and <a href="https://github.com/microprediction/pandemic/tree/master/examples_of_surrogate_use">examples of using the public
database of simulations</a> generated by this model. 

### Other entry points. 

- pandemic.simulation.simulate is the main routine
- pandemic.client offers an alternative in object oriented style 

### Modifying

See pandemic/client.py for examples of extending the newer style to include data storage, lockdown and so forth. 

#### Docker

Pandemic can be run in a docker container. 

```
docker run xtellurian/pandemic
```

### Crowd-sourced surrogate model 

See <a href="https://www.swarmprediction.com/about.html">SwarmPrediction.com</a> for an explanation of 
a SETI-like project to crowd-source a surrogate model. 

### Basic elements of the model 

Covered in detail in this [article](https://www.linkedin.com/pulse/dear-new-zealand-heres-how-simulate-covid-19-all-your-cotton-phd/). As noted some analytical properties of 
special cases of the model are discussed in a [working paper](https://www.overleaf.com/read/sgjvfxydcwpk). 

### Contributing 

Opinions and issues are most welcome. 